function initMap() {
    
    const options = {
        zoom: 15,
        center:{lat: 4.921365, lng: 114.952407},
        styles: [{"stylers": [{ "saturation": -100 }]}]
    }
    //GOOGLE MAP OBJECT
    var map = new google.maps.Map(document.getElementById('gmap'), options)
         
    var bedbMarker = 'http://dev.adisonmarketingservices.com/bedb-marker.png';
        
    var markers = [
        
        {
            coords:{lat:4.921365, lng:114.952407},
            iconImage:bedbMarker,
            content:'<div class="iw-bedb-wrap">' +
            '<header class="iw-title">The Brunei Economic Development Board</header>' +
            '<address class="iw-address">Level 4, Tower Block, <br> Ministry of Finance & Economy, <br> Commonwealth Drive, <br> Bandar Seri Begawan BB3910 <br> Brunei Darussalam</address>'+
            '</div>'
        }
    ];
        
    //CREATE INFOWINDOW OBJECT
    var infoWindow = new google.maps.InfoWindow();
    //Loop through markers
    for(var i = 0; i < markers.length; i++) {
        
        var props = markers[i];
        // ADD MARKERS
        var marker = new google.maps.Marker({
            position:props.coords,
            map:map

        });
        
        // CHECK IF CUSTOM ICON IS AVAIL.
        if(props.iconImage){
            marker.setIcon(props.iconImage);
        }
        
        //Attach click event to the marker.
        (function(marker, props){
            google.maps.event.addListener(marker, 'click', function(e){
                infoWindow.setContent(props.content);
                infoWindow.open(map, this);
            });
            
            //CUSTOMIZE INFOWINDOW
            google.maps.event.addListener(infoWindow, 'domready', function() {

               // Reference to the DIV which receives the contents of the infowindow using jQuery
               var iwOuter = $('.gm-style-iw');

               /* The DIV we want to change is above the .gm-style-iw DIV.
                * So, we use jQuery and create a iwBackground variable,
                * and took advantage of the existing reference to .gm-style-iw for the previous DIV with .prev().
                */
               var iwBackground = iwOuter.prev();

               // Remove the background shadow DIV
               iwBackground.children(':nth-child(2)').css({'display' : 'none'});

               // Remove the white background DIV
               iwBackground.children(':nth-child(4)').css({'display' : 'none'});
                
               iwBackground.children(':nth-child(1)').attr('style', function(i,s){ return s + 'display: none !important;'});
                
                //CUSTOMIZE TAIL OF INFOWINDOW
               iwBackground.children(':nth-child(3)').children('div:nth-child(1)').children('div').attr('style', function(i,s){ return s + 'transform: skewX(0deg) !important;' + 'width: 1px;' + 'left: 15px;' + 'background-color: #333'});
                
                iwBackground.children(':nth-child(3)').children('div:nth-child(2)').children('div').attr('style', function(i,s){ return s + 'transform: skewX(0deg) !important;' + 'width: 1px;' + 'background-color: #333'});
                
                var iwCloseBtn = iwOuter.next();

                // Apply the desired effect to the close button
                iwCloseBtn.css({
                  opacity: '0.8', // by default the close button has an opacity of 0.7
                  right: '13px', top: '26px', // button repositioning
                });

            }); //infoWindow
            
            
        })(marker, props);
        
    } // ADD MARKER FOR LOOP
        
        
} // initMap